diff a/test/micro/org/openjdk/bench/valhalla/types/Int32.java b/test/micro/org/openjdk/bench/valhalla/types/Int32.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/Int32.java
@@ -0,0 +1,40 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public interface Int32 extends Comparable<Int32>  {
+
+    public long longValue();
+
+    public int intValue();
+
+    public Int32 neg();
+
+    public Int32 add(Int32 o);
+
+    public Int32 sub(Int32 o);
+
+    public Int32 mult(Int32 o);
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/Int64.java b/test/micro/org/openjdk/bench/valhalla/types/Int64.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/Int64.java
@@ -0,0 +1,31 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public interface Int64 {
+
+    public long longValue();
+
+    public int intValue();
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/Opt.java b/test/micro/org/openjdk/bench/valhalla/types/Opt.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/Opt.java
@@ -0,0 +1,31 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public interface Opt<T> {
+
+    public T get();
+    public boolean isPresent();
+    public boolean isEmpty();
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/Q128byte.java b/test/micro/org/openjdk/bench/valhalla/types/Q128byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/Q128byte.java
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public value class Q128byte implements Int128, ByByte {
+
+    public final Q64byte v0;
+    public final Q64byte v1;
+
+    public Q128byte(long v) {
+        this(0, v);
+    }
+
+    public Q128byte(long hi, long lo) {
+        this.v0 = new Q64byte(hi);
+        this.v1 = new Q64byte(lo);
+    }
+
+    @Override
+    public int intValue() {
+        return v1.intValue();
+    }
+
+    @Override
+    public long longValue() {
+        return loValue();
+    }
+
+    @Override
+    public long hiValue() {
+        return v0.longValue();
+    }
+
+    @Override
+    public long loValue() {
+        return v1.longValue();
+    }
+
+    @Override
+    public byte byteSum() {
+        return (byte) (v0.byteSum() + v1.byteSum());
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/Q128int.java b/test/micro/org/openjdk/bench/valhalla/types/Q128int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/Q128int.java
@@ -0,0 +1,67 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public value class Q128int implements Int128, ByInt {
+
+    public final Q64int v0;
+    public final Q64int v1;
+
+    public Q128int() {
+        this(0, 0);
+    }
+
+    public Q128int(long v) {
+        this(0, v);
+    }
+
+    public Q128int(long hi, long lo) {
+        this.v0 = new Q64int(hi);
+        this.v1 = new Q64int(lo);
+    }
+
+    @Override
+    public int intValue() {
+        return v1.intValue();
+    }
+
+    @Override
+    public long longValue() {
+        return loValue();
+    }
+
+    @Override
+    public long hiValue() {
+        return v0.longValue();
+    }
+
+    @Override
+    public long loValue() {
+        return v1.longValue();
+    }
+
+    @Override
+    public int intSum() {
+        return v0.intSum() + v1.intSum();
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/Q128long.java b/test/micro/org/openjdk/bench/valhalla/types/Q128long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/Q128long.java
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public value class Q128long implements Int128, ByLong {
+
+    public final long v0;
+    public final long v1;
+
+    public Q128long(long v) {
+        this(0, v);
+    }
+
+    public Q128long(long hi, long lo) {
+        this.v0 = hi;
+        this.v1 = lo;
+    }
+
+    @Override
+    public int intValue() {
+        return (int)longValue();
+    }
+
+    @Override
+    public long longValue() {
+        return loValue();
+    }
+
+    @Override
+    public long hiValue() {
+        return v0;
+    }
+
+    @Override
+    public long loValue() {
+        return v1;
+    }
+
+    @Override
+    public long longSum() {
+        return v0 + v1;
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/Q32byte.java b/test/micro/org/openjdk/bench/valhalla/types/Q32byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/Q32byte.java
@@ -0,0 +1,88 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public value class Q32byte implements Int32, ByByte {
+
+    public final byte v0;
+    public final byte v1;
+    public final byte v2;
+    public final byte v3;
+
+    public Q32byte() {
+        this(0);
+    }
+
+    public Q32byte(int v) {
+        this((byte) (v >>> 24), (byte) (v >>> 16), (byte) (v >>> 8), (byte) (v));
+    }
+
+    public Q32byte(byte v0, byte v1, byte v2, byte v3) {
+        this.v0 = v0;
+        this.v1 = v1;
+        this.v2 = v2;
+        this.v3 = v3;
+    }
+
+    private static final int MASK = 0xFF;
+
+    @Override
+    public long longValue() {
+        return (long) intValue();
+    }
+
+    @Override
+    public int intValue() {
+        return (((v0 & MASK) << 24) | ((v1 & MASK) << 16) | ((v2 & MASK) << 8) | (v3 & MASK));
+    }
+
+    @Override
+    public Int32 neg() {
+        return new Q32byte(-intValue());
+    }
+
+    @Override
+    public Int32 add(Int32 o) {
+        return new Q32byte(intValue() + o.intValue());
+    }
+
+    @Override
+    public Int32 sub(Int32 o) {
+        return new Q32byte(intValue() - o.intValue());
+    }
+
+    @Override
+    public Int32 mult(Int32 o) {
+        return new Q32byte(intValue() * o.intValue());
+    }
+
+    @Override
+    public int compareTo(Int32 o) {
+        return Integer.compare(intValue(), o.intValue());
+    }
+
+    @Override
+    public byte byteSum() {
+        return (byte) (v0 + v1 + v2 + v3);
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/Q32int.java b/test/micro/org/openjdk/bench/valhalla/types/Q32int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/Q32int.java
@@ -0,0 +1,92 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public value class Q32int implements Int32, ByInt {
+
+    public final int v0;
+
+    public Q32int() {
+        v0 = 0;
+    }
+
+    public Q32int(int val) {
+        this.v0 = val;
+    }
+
+    @Override
+    public long longValue() {
+        return (long)v0;
+    }
+
+    @Override
+    public int intValue() {
+        return v0;
+    }
+
+    @Override
+    public Int32 neg() {
+        return new Q32int(-v0);
+    }
+
+    @Override
+    public Int32 add(Int32 o) {
+        return new Q32int(v0 + o.intValue());
+    }
+
+    public Int32 add(Q32int o) {
+        return new Q32int(v0 + o.v0);
+    }
+
+    @Override
+    public Int32 sub(Int32 o) {
+        return new Q32int(v0 - o.intValue());
+    }
+
+    public Int32 sub(Q32int o) {
+        return new Q32int(v0 - o.v0);
+    }
+
+    @Override
+    public Int32 mult(Int32 o) {
+        return new Q32int(v0 * o.intValue());
+    }
+
+    public Int32 mult(Q32int o) {
+        return new Q32int(v0 * o.v0);
+    }
+
+    @Override
+    public int compareTo(Int32 o) {
+        return Integer.compare(v0, o.intValue());
+    }
+
+    public int compareTo(Q32int o) {
+        return Integer.compare(v0, o.v0);
+    }
+
+    @Override
+    public int intSum() {
+        return v0;
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/Q64byte.java b/test/micro/org/openjdk/bench/valhalla/types/Q64byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/Q64byte.java
@@ -0,0 +1,60 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public value class Q64byte implements Int64, ByByte {
+
+    public final Q32byte v0;
+    public final Q32byte v1;
+
+    public Q64byte() {
+        this.v0 = new Q32byte();
+        this.v1 = new Q32byte();
+    }
+
+    public Q64byte(long v) {
+        this((int) (v >>> 32), (int) v);
+    }
+
+    public Q64byte(int hi, int lo) {
+        this.v0 = new Q32byte(hi);
+        this.v1 = new Q32byte(lo);
+    }
+
+    private static final long MASK = 0xFFFFFFFFL;
+
+    @Override
+    public long longValue() {
+        return (v0.intValue() & MASK) << 32 | (v1.intValue() & MASK);
+    }
+
+    @Override
+    public int intValue() {
+        return v1.intValue();
+    }
+
+    @Override
+    public byte byteSum() {
+        return (byte) (v0.byteSum() + v1.byteSum());
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/Q64int.java b/test/micro/org/openjdk/bench/valhalla/types/Q64int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/Q64int.java
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public value class Q64int implements Int64, ByInt {
+
+    public final Q32int v0;
+    public final Q32int v1;
+
+    public Q64int() {
+        this(0);
+    }
+
+    public Q64int(long v) {
+        this((int) (v >>> 32), (int) v);
+    }
+
+    public Q64int(int hi, int lo) {
+        this.v0 = new Q32int(hi);
+        this.v1 = new Q32int(lo);
+    }
+
+    private static final long MASK = 0xFFFFFFFFL;
+
+    @Override
+    public long longValue() {
+        return (v0.intValue() & MASK) << 32 | (v1.intValue() & MASK);
+    }
+
+    @Override
+    public int intValue() {
+        return v1.intValue();
+    }
+
+    @Override
+    public int intSum() {
+        return v0.intSum() + v1.intSum();
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/Q64long.java b/test/micro/org/openjdk/bench/valhalla/types/Q64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/Q64long.java
@@ -0,0 +1,52 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public value class Q64long implements Int64, ByLong {
+
+    public final long v0;
+
+    public Q64long() {
+        this(0);
+    }
+
+    public Q64long(long v0) {
+        this.v0 = v0;
+    }
+
+    @Override
+    public long longValue() {
+        return v0;
+    }
+
+    @Override
+    public int intValue() {
+        return (int)v0;
+    }
+
+    @Override
+    public long longSum() {
+        return v0;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/QComplex.java b/test/micro/org/openjdk/bench/valhalla/types/QComplex.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/QComplex.java
@@ -0,0 +1,62 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public value class QComplex implements Complex {
+
+    public final double re;
+    public final double im;
+
+    public QComplex(double re, double im) {
+        this.re =  re;
+        this.im =  im;
+    }
+
+    @Override
+    public double re() { return re; }
+
+    @Override
+    public double im() { return im; }
+
+    @Override
+    public QComplex add(Complex that) {
+        return new QComplex(this.re + that.re(), this.im + that.im());
+    }
+
+    public QComplex add(QComplex that) {
+        return new QComplex(this.re + that.re, this.im + that.im);
+    }
+
+    @Override
+    public QComplex mul(Complex that) {
+        return new QComplex(this.re * that.re() - this.im * that.im(),
+                           this.re * that.im() + this.im * that.re());
+    }
+
+    public QComplex mul(QComplex that) {
+        return new QComplex(this.re * that.re - this.im * that.im,
+                           this.re * that.im + this.im * that.re);
+    }
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/QOpt.java b/test/micro/org/openjdk/bench/valhalla/types/QOpt.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/QOpt.java
@@ -0,0 +1,57 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+import java.util.NoSuchElementException;
+
+public value class QOpt<T> implements Opt<T> {
+
+    public final T value;
+
+    private QOpt(T value) {
+        this.value = value;
+    }
+
+    public static <T> QOpt<T> of() {
+        return new QOpt<>(null);
+    }
+
+    public static <T> QOpt<T> of(T value) {
+        return new QOpt<>(value);
+    }
+
+    public T get() {
+        if (value == null) {
+            throw new NoSuchElementException("No value present");
+        }
+        return value;
+    }
+
+    public boolean isPresent() {
+        return value != null;
+    }
+
+    public boolean isEmpty() {
+        return value == null;
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/R128int.java b/test/micro/org/openjdk/bench/valhalla/types/R128int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/R128int.java
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public class R128int implements Int128, ByInt {
+
+    public final int v0;
+    public final int v1;
+    public final int v2;
+    public final int v3;
+
+    public R128int(long v) {
+        this(0, 0, (int) (v >>> 32), (int) v);
+    }
+
+    public R128int(int v0, int v1, int v2, int v3) {
+        this.v0 = v0;
+        this.v1 = v1;
+        this.v2 = v2;
+        this.v3 = v3;
+    }
+
+    private static final long MASK = 0xFFFFFFFFL;
+
+    @Override
+    public int intValue() {
+        return v3;
+    }
+
+    @Override
+    public long longValue() {
+        return loValue();
+    }
+
+    @Override
+    public long hiValue() {
+        return (v0 & MASK) << 32 | (v1 & MASK);
+    }
+
+    @Override
+    public long loValue() {
+        return (v2 & MASK) << 32 | (v3 & MASK);
+    }
+
+    @Override
+    public int intSum() {
+        return v0 + v1 + v2 + v3;
+    }
+}
diff a/test/micro/org/openjdk/bench/valhalla/types/R128long.java b/test/micro/org/openjdk/bench/valhalla/types/R128long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/types/R128long.java
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.types;
+
+public class R128long implements Int128, ByLong {
+
+    public final long v0;
+    public final long v1;
+
+    public R128long(long v) {
+        this(0, v);
+    }
+
+    public R128long(long hi, long lo) {
+        this.v0 = hi;
+        this.v1 = lo;
+    }
+
+    @Override
+    public int intValue() {
+        return (int)loValue();
+    }
+
+    @Override
+    public long longValue() {
+        return loValue();
+    }
+
+    @Override
+    public long hiValue() {
+        return v0;
+    }
+
+    @Override
+    public long loValue() {
+        return v1;
+    }
+
+    @Override
+    public long longSum() {
+        return v0 + v1;
+    }
+}
